function f = objfun(x,B,hvar,P,Sigma,K,ntarget)

qmat = zeros(K,K);
for i = 1:K
    qmat(:,i) = x((K*(i-1))+1:K*i);
end

% Variance share
om = zeros(ntarget,1);
for shocknum = 1:ntarget
    top = 0;
    bottom = 0;
    for j=0:hvar(shocknum)
        Bvar = B(shocknum,K*j+1:K*j+K); 
        top = top + (Bvar*P*qmat(:,shocknum))*(qmat(:,shocknum)'*P'*Bvar'); 
        bottom = bottom + Bvar*Sigma*Bvar';
        om(shocknum,1) = om(shocknum,1) + top/bottom;
    end
end
f = -sum(om(:));